-------------------------------------------------------------------------------
--   OCO Source Materials
--
--   Licensed Materials - Property of IBM
--
--   5724-C02
--
--   (C) Copyright IBM Corp. 2003  All Rights Reserved.
--
--   US Government Users Restricted Rights - Use, duplication or
--   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-------------------------------------------------------------------------------
--    File Information: %W%
--    Revision: %I%
--    Date: %G% %U%
-------------------------------------------------------------------------------

--#IGNORE_ERROR
DROP VIEW BWM.UP_WEB_NAME;
--#IGNORE_ERROR
DROP TABLE BWM.UP_MAP_PROBE;
--#IGNORE_ERROR
DROP TABLE BWM.UP_COMP_LONG;


CREATE TABLE BWM.UP_MAP_PROBE(
    ORIG_COMP_ID INTEGER NOT NULL,
    NEW_COMP_ID INTEGER,
    TX_ND_ID INTEGER,
    TX_ND_COMP_ID INTEGER,
    TX_COMP_ID INTEGER,
    IP_HOST_COMP_ID INTEGER,
    PROBE_TYPE VARCHAR(4),
    WEBSITE_ID INTEGER,
    SITE_LEN INTEGER,
    SITE_LONG_LEN INTEGER,
    WEBSITE_PATH_ID INTEGER,
    PATH_LEN INTEGER,
    PATH_LONG_LEN INTEGER,
    WEBSITE_QUERY_ID INTEGER,
    QUERY_LEN INTEGER,
    QUERY_LONG_LEN INTEGER,
    PRIMARY KEY (ORIG_COMP_ID))
    ;

CREATE TABLE BWM.UP_COMP_LONG(
    COMP_ID INTEGER NOT NULL,
    COMP_NM LONG VARCHAR,
    PRIMARY KEY (COMP_ID)
    );

--#IGNORE_ERROR
CREATE VIEW BWM.UP_WEB_NAME (
    COMP_ID,
    LONGER_NAME) AS
 SELECT
  B.WEBSITE_ID,
  C.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  TWG.COMP C
 WHERE
  B.WEBSITE_ID=C.COMP_ID AND
  B.SITE_LONG_LEN IS NULL
 UNION
 SELECT
  B.WEBSITE_ID,
  L.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  BWM.COMP_LONG L
 WHERE
  B.WEBSITE_ID=L.COMP_ID AND
  B.SITE_LONG_LEN IS NOT NULL
 UNION
 SELECT
  B.WEBSITE_PATH_ID,
  C.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  TWG.COMP C
 WHERE
  B.WEBSITE_PATH_ID=C.COMP_ID AND
  B.PATH_LONG_LEN IS NULL
 UNION
 SELECT
  B.WEBSITE_PATH_ID,
  L.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  BWM.COMP_LONG L
 WHERE
  B.WEBSITE_PATH_ID=L.COMP_ID AND
  B.PATH_LONG_LEN IS NOT NULL
 UNION
 SELECT
  B.WEBSITE_QUERY_ID,
  C.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  TWG.COMP C
 WHERE
  B.WEBSITE_QUERY_ID=C.COMP_ID AND
  B.QUERY_LONG_LEN IS NULL
 UNION
 SELECT
  B.WEBSITE_QUERY_ID,
  L.COMP_NM
 FROM
  BWM.UP_MAP_PROBE B,
  BWM.COMP_LONG L
 WHERE
  B.WEBSITE_QUERY_ID=L.COMP_ID AND
  B.QUERY_LONG_LEN IS NOT NULL
;
