-------------------------------------------------------------------------------
--   OCO Source Materials
--
--   Licensed Materials - Property of IBM
--
--   5724-C02
--
--   (C) Copyright IBM Corp. 2003  All Rights Reserved.
--
--   US Government Users Restricted Rights - Use, duplication or
--   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-------------------------------------------------------------------------------
--    File Information: src/ReportUI/tedw/tedw_apps_etl/bwm/pkg/v510/etl/sql/bwm_m05_s030_mart_load.db2, tp_tedw, ReportUI_52
--    Revision: 1.15
--    Date: 8/7/03 10:09:42
-------------------------------------------------------------------------------

----------------------
--  HOST
---------------------
INSERT INTO BWM.D_HOST(
    HOST_ID,
    HOST_NM,
    IP_ADDRESS,
    CUST_NM,
    CENTER_NM)
 SELECT
  0,
  HOST_NM,
  IP_ADDRESS,
  CUST_NM,
  CENTER_NM
 FROM
  BWM.T_HOST B
 WHERE
  NOT EXISTS
  (
   SELECT 1
   FROM BWM.D_HOST A
   WHERE
    A.IP_ADDRESS=B.IP_ADDRESS AND
    A.CENTER_NM=B.CENTER_NM AND
    A.CUST_NM=B.CUST_NM AND
    A.HOST_NM=B.HOST_NM
  )
 GROUP BY IP_ADDRESS,CENTER_NM,CUST_NM,HOST_NM
;

UPDATE BWM.T_HOST A
 SET HOST_ID=
    (
     SELECT B.HOST_ID FROM BWM.D_HOST B
     WHERE
      A.IP_ADDRESS=B.IP_ADDRESS AND
      A.CENTER_NM=B.CENTER_NM AND
      A.CUST_NM=B.CUST_NM AND
      A.HOST_NM=B.HOST_NM
    );

----------------------
--  APP
---------------------
INSERT INTO BWM.D_APP(
    APP_ID,
    J2EESERVER_NAME,
    J2EE_CELL_NAME,
    J2EE_DOMAIN,
    J2EE_NODE,
    J2EE_TYPE_VER,
    PROBE_NAME,
    PROBE_HOST)
 SELECT
  0,
  J2EESERVER_NAME,
  J2EE_CELL_NAME,
  J2EE_DOMAIN,
  J2EE_NODE,
  J2EE_TYPE_VER,
  PROBE_NAME,
  PROBE_HOST
 FROM
  BWM.T_APP B
 WHERE
  NOT EXISTS
  (
   SELECT 1
   FROM BWM.D_APP A
   WHERE
    A.J2EESERVER_NAME=B.J2EESERVER_NAME AND
    A.J2EE_CELL_NAME=B.J2EE_CELL_NAME AND
    A.J2EE_DOMAIN=B.J2EE_DOMAIN AND
    A.J2EE_NODE=B.J2EE_NODE AND
    A.PROBE_NAME=B.PROBE_NAME AND
    A.PROBE_HOST=B.PROBE_HOST AND
    A.J2EE_TYPE_VER=B.J2EE_TYPE_VER
  )
 GROUP BY J2EESERVER_NAME,J2EE_CELL_NAME,J2EE_DOMAIN,J2EE_NODE,J2EE_TYPE_VER,PROBE_NAME,PROBE_HOST
;

UPDATE BWM.T_APP A
 SET APP_ID=
    (
     SELECT B.APP_ID FROM BWM.D_APP B
     WHERE
      A.J2EESERVER_NAME=B.J2EESERVER_NAME AND
      A.J2EE_CELL_NAME=B.J2EE_CELL_NAME AND
      A.J2EE_DOMAIN=B.J2EE_DOMAIN AND
      A.J2EE_NODE=B.J2EE_NODE AND
      A.PROBE_NAME=B.PROBE_NAME AND
      A.PROBE_HOST=B.PROBE_HOST AND
      A.J2EE_TYPE_VER=B.J2EE_TYPE_VER
    );

----------------------
--  TX
---------------------
INSERT INTO BWM.D_TX(
    TX_ID,
    TX_NAME,
    TX_DESC,
    URL_PROTOCOL,
    WEBSITE,
    WEBSITE_PATH,
    WEBSITE_QUERY)
 SELECT
  0,
  TX_NAME,
  TX_DESC,
  URL_PROTOCOL,
  WEBSITE,
  WEBSITE_PATH,
  WEBSITE_QUERY
 FROM
  BWM.T_TX B
 WHERE
  NOT EXISTS
  (
   SELECT 1
   FROM BWM.D_TX A
   WHERE
    A.TX_NAME=B.TX_NAME AND
    A.TX_DESC=B.TX_DESC AND
    A.URL_PROTOCOL=B.URL_PROTOCOL AND
    A.WEBSITE=B.WEBSITE AND
    A.WEBSITE_PATH=B.WEBSITE_PATH AND
    A.WEBSITE_QUERY=B.WEBSITE_QUERY
  )
 GROUP BY
  TX_NAME,TX_DESC,URL_PROTOCOL,WEBSITE,WEBSITE_PATH,WEBSITE_QUERY
;

UPDATE BWM.T_TX A
 SET TX_ID=
    (
     SELECT B.TX_ID FROM BWM.D_TX B
     WHERE
      A.TX_NAME=B.TX_NAME AND
      A.TX_DESC=B.TX_DESC AND
      A.URL_PROTOCOL=B.URL_PROTOCOL AND
      A.WEBSITE=B.WEBSITE AND
      A.WEBSITE_PATH=B.WEBSITE_PATH AND
      A.WEBSITE_QUERY=B.WEBSITE_QUERY
    );


----------------------
--  TX_ND
---------------------
INSERT INTO BWM.D_TX_ND(
    TX_ND_ID,
    TX_ND_NAME,
    MANAGEMENT_POLICY,
    INVOKING_USER,
    CURRENT_CDW_ID,
    ROOT_CDW_ID,
    PARENT_CDW_ID)
 SELECT
  0,
  TX_ND_NAME,
  MANAGEMENT_POLICY,
  INVOKING_USER,
  CHAR(ORIG_TX_ND_ID),
  ROOT_CDW_ID,
  PARENT_CDW_ID
 FROM
  BWM.T_TX_ND B
 WHERE
  NOT EXISTS
  (
   SELECT 1
   FROM BWM.D_TX_ND A
   WHERE
    A.TX_ND_NAME=B.TX_ND_NAME AND
    A.MANAGEMENT_POLICY=B.MANAGEMENT_POLICY AND
    A.INVOKING_USER=B.INVOKING_USER AND
    A.CURRENT_CDW_ID=CHAR(B.ORIG_TX_ND_ID) AND
    A.ROOT_CDW_ID=B.ROOT_CDW_ID AND
    A.PARENT_CDW_ID=B.PARENT_CDW_ID
  )
 GROUP BY
  TX_ND_NAME,MANAGEMENT_POLICY,INVOKING_USER,ORIG_TX_ND_ID,ROOT_CDW_ID,PARENT_CDW_ID
;

UPDATE BWM.T_TX_ND A
 SET TX_ND_ID=
    (
     SELECT B.TX_ND_ID FROM BWM.D_TX_ND B
     WHERE
      A.TX_ND_NAME=B.TX_ND_NAME AND
      A.MANAGEMENT_POLICY=B.MANAGEMENT_POLICY AND
      A.INVOKING_USER=B.INVOKING_USER AND
      CHAR(A.ORIG_TX_ND_ID)=B.CURRENT_CDW_ID AND
      A.ROOT_CDW_ID=B.ROOT_CDW_ID AND
      A.PARENT_CDW_ID=B.PARENT_CDW_ID
    );


----------------------
--  TX_ND_METRIC
---------------------
INSERT INTO BWM.D_TX_ND_METRIC (
    METRIC_ID,
    MET_CATEGORY,
    MET_DESC,
    MET_NAME,
    MET_UNITS,
    MIN_EXISTS,
    MAX_EXISTS,
    AVG_EXISTS,
    TOTAL_EXISTS,
    MSRC_NM)
 SELECT
  0,
  MET_CATEGORY,
  MET_DESC,
  MET_NAME,
  MET_UNITS,
  MIN_EXISTS,
  MAX_EXISTS,
  AVG_EXISTS,
  TOTAL_EXISTS,
  MSRC_NM
 FROM
  BWM.T_TX_ND_METRIC B
 WHERE
  NOT EXISTS
  (
   SELECT 1 FROM BWM.D_TX_ND_METRIC A
   WHERE
    A.MET_CATEGORY=B.MET_CATEGORY AND
    A.MET_DESC=B.MET_DESC AND
    A.MET_NAME=B.MET_NAME AND
    A.MET_UNITS=B.MET_UNITS AND
    A.MIN_EXISTS=B.MIN_EXISTS AND
    A.MAX_EXISTS=B.MAX_EXISTS AND
    A.AVG_EXISTS=B.AVG_EXISTS AND
    A.TOTAL_EXISTS=B.TOTAL_EXISTS AND
    A.MSRC_NM=B.MSRC_NM
  )
 GROUP BY
  METRIC_ID,MET_CATEGORY,MET_DESC,MET_NAME,MET_UNITS,MIN_EXISTS,MAX_EXISTS,
  AVG_EXISTS,TOTAL_EXISTS,MSRC_NM
;

UPDATE BWM.T_TX_ND_METRIC A
 SET METRIC_ID=
    (
     SELECT B.METRIC_ID FROM BWM.D_TX_ND_METRIC B
     WHERE
      A.MET_CATEGORY=B.MET_CATEGORY AND
      A.MET_DESC=B.MET_DESC AND
      A.MET_NAME=B.MET_NAME AND
      A.MET_UNITS=B.MET_UNITS AND
      A.MIN_EXISTS=B.MIN_EXISTS AND
      A.MAX_EXISTS=B.MAX_EXISTS AND
      A.AVG_EXISTS=B.AVG_EXISTS AND
      A.TOTAL_EXISTS=B.TOTAL_EXISTS AND
      A.MSRC_NM=B.MSRC_NM
    );

--#IGNORE_ERROR
DROP TABLE BWM.TMP_HOST;

CREATE TABLE BWM.TMP_HOST(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    HOST_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID, MSMT_ID))
;


INSERT INTO BWM.TMP_HOST
 SELECT
  S.CDW_ID,
  S.MSMT_ID,
  T.HOST_ID
 FROM
  BWM.T_HOST T,
  BWM.STG_TX_ND_HR S
 WHERE
  S.ORIG_HOST_ID=T.ORIG_HOST_ID AND
  S.CDW_ID=T.CDW_ID
;

--#IGNORE_ERROR
DROP TABLE BWM.TMP_APP;

CREATE TABLE BWM.TMP_APP(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    APP_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID,MSMT_ID))
;

INSERT INTO BWM.TMP_APP
 SELECT
  S.CDW_ID,
  S.MSMT_ID,
  T.APP_ID
 FROM
  BWM.T_APP T,
  BWM.STG_TX_ND_HR S
 WHERE
  S.ORIG_APP_ID=T.ORIG_APP_ID AND
  S.CDW_ID=T.CDW_ID
;

--#IGNORE_ERROR
DROP TABLE BWM.TMP_TX;

CREATE TABLE BWM.TMP_TX(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    TX_ID INTEGER NOT NULL,
    PRIMARY KEY(cdw_id,msmt_id))
;

INSERT INTO BWM.TMP_TX
 SELECT
  S.CDW_ID,
  S.MSMT_ID,
  T.TX_ID
 FROM
  BWM.T_TX T,
  BWM.STG_TX_ND_HR S
 WHERE
  S.ORIG_TX_ID=T.ORIG_TX_ID AND
  S.CDW_ID=T.CDW_ID
;


--#IGNORE_ERROR
DROP TABLE BWM.TMP_TX_ND_MET;

CREATE TABLE BWM.TMP_TX_ND_MET(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    METRIC_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID,MSMT_ID))
;

INSERT INTO BWM.TMP_TX_ND_MET
 SELECT
  S.CDW_ID,
  S.MSMT_ID,
  T.METRIC_ID
 FROM
  BWM.T_TX_ND_METRIC T,
  BWM.STG_TX_ND_HR S
 WHERE
  S.ORIG_METRIC_ID=T.ORIG_METRIC_ID AND
  S.CDW_ID=T.CDW_ID
;

-- now for the insert statement for the fact table
-- populated from a combination of dimension tables,
-- translation tables and staging table for the fact
-- table.  this is all so that ids from different
-- cdws can be preserved.

----------------------------
-- hourly fact table: TX_NODE
-----------------------------

--#IGNORE_ERROR
DROP TABLE BWM.TMP_TX_ND;

CREATE TABLE BWM.TMP_TX_ND(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    TX_ND_ID INTEGER NOT NULL,
    MEAS_HOUR TIMESTAMP NOT NULL,
    MIN_VALUE DOUBLE,
    MAX_VALUE DOUBLE,
    AVG_VALUE DOUBLE,
    TOTAL_VALUE DOUBLE,
    SAMPLE_COUNT DOUBLE,
    ERROR_COUNT DOUBLE,
    PRIMARY KEY(CDW_ID, MSMT_ID))
;

INSERT INTO BWM.TMP_TX_ND
 SELECT
  S.CDW_ID,
  S.MSMT_ID,
  T.TX_ND_ID,
  S.MEAS_HOUR,
  S.MIN_VALUE,
  S.MAX_VALUE,
  S.AVG_VALUE,
  S.TOTAL_VALUE,
  S.SAMPLE_COUNT,
  S.ERROR_COUNT
 FROM
  BWM.T_TX_ND T,
  BWM.STG_TX_ND_HR S
 WHERE
  S.ORIG_TX_ND_ID=T.ORIG_TX_ND_ID AND
  S.CDW_ID=T.CDW_ID
;



--#IGNORE_ERROR
DROP TABLE BWM.TMP_JOIN1;

CREATE TABLE BWM.TMP_JOIN1(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    HOST_ID INTEGER NOT NULL,
    APP_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID, MSMT_ID))
;

INSERT INTO BWM.TMP_JOIN1
SELECT
    H.CDW_ID,
    H.MSMT_ID,
    H.HOST_ID,
    A.APP_ID
FROM
    BWM.TMP_HOST H,
    BWM.TMP_APP A
WHERE
    H.CDW_ID = A.CDW_ID AND
    H.MSMT_ID = A.MSMT_ID
;

--#IGNORE_ERROR
DROP TABLE BWM.TMP_JOIN2;

CREATE TABLE BWM.TMP_JOIN2(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    HOST_ID INTEGER NOT NULL,
    APP_ID INTEGER NOT NULL,
    TX_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID, MSMT_ID))
;

INSERT INTO BWM.TMP_JOIN2
SELECT
    J.CDW_ID,
    J.MSMT_ID,
    J.HOST_ID,
    J.APP_ID,
    T.TX_ID
FROM
    BWM.TMP_JOIN1 J,
    BWM.TMP_TX T
WHERE
    J.CDW_ID = T.CDW_ID AND
    J.MSMT_ID = T.MSMT_ID
;

--#IGNORE_ERROR
DROP TABLE BWM.TMP_JOIN3;

CREATE TABLE BWM.TMP_JOIN3(
    CDW_ID INTEGER NOT NULL,
    MSMT_ID BIGINT NOT NULL,
    HOST_ID INTEGER NOT NULL,
    APP_ID INTEGER NOT NULL,
    TX_ID INTEGER NOT NULL,
    METRIC_ID INTEGER NOT NULL,
    PRIMARY KEY(CDW_ID, MSMT_ID))
;

INSERT INTO BWM.TMP_JOIN3
SELECT
    J.CDW_ID,
    J.MSMT_ID,
    J.HOST_ID,
    J.APP_ID,
    J.TX_ID,
    M.METRIC_ID
FROM
    BWM.TMP_JOIN2 J,
    BWM.TMP_TX_ND_MET M
WHERE
    J.CDW_ID = M.CDW_ID AND
    J.MSMT_ID = M.MSMT_ID
;

INSERT INTO BWM.F_TX_ND_HOUR(
    METRIC_ID,
    HOST_ID,
    APP_ID,
    TX_ID,
    TX_ND_ID,
    MEAS_HOUR,
    MIN_VALUE,
    MAX_VALUE,
    AVG_VALUE,
    TOTAL_VALUE,
    SAMPLE_COUNT,
    ERROR_COUNT)
 SELECT
  J.METRIC_ID,
  J.HOST_ID,
  J.APP_ID,
  J.TX_ID,
  T.TX_ND_ID,
  T.MEAS_HOUR,
  T.MIN_VALUE,
  T.MAX_VALUE,
  T.AVG_VALUE,
  T.TOTAL_VALUE,
  T.SAMPLE_COUNT,
  T.ERROR_COUNT
 FROM
    BWM.TMP_JOIN3 J,
    BWM.TMP_TX_ND T
 WHERE
    J.CDW_ID = T.CDW_ID AND
    J.MSMT_ID = T.MSMT_ID
 ;

----------------------
--  COMP_NAME_LONG
---------------------
UPDATE BWM.COMP_NAME_LONG A
 SET COMP_ID=
    (
     SELECT B.TX_ID FROM BWM.T_TX B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_TX_ID
     UNION
     SELECT B.HOST_ID FROM BWM.T_HOST B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_HOST_ID
     UNION
     SELECT B.APP_ID FROM BWM.T_APP B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_APP_ID
     UNION
     SELECT B.TX_ND_ID FROM BWM.T_TX_ND B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_TX_ND_ID
    );

----------------------
--  COMP_ATTR_LONG
---------------------
UPDATE BWM.COMP_ATTR_LONG A
 SET COMP_ID=
    (
     SELECT B.TX_ID FROM BWM.T_TX B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_TX_ID
     UNION
     SELECT B.HOST_ID FROM BWM.T_HOST B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_HOST_ID
     UNION
     SELECT B.APP_ID FROM BWM.T_APP B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_APP_ID
     UNION
     SELECT B.TX_ND_ID FROM BWM.T_TX_ND B
      WHERE
       A.ORIG_COMP_ID=B.ORIG_TX_ND_ID
    );
    