######################################################################
#
# (C) Copyright IBM Corp. 2002.  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#
#
#######################################################################
#
#-    File Information: %W%
#-    Revision: %I%
#-    Date: %G% %U%

# This script allows you to run the BWM_c05_ETL1_Process 
# of the product IBM Tivoli Monitoring v5.1.1 
# by command line

# Interpreter Required:
#       NT/2000 = BASH
#       Unix    = SH (Bourne Shell)

# Install Steps Required Before this Script Executes:
#       1 - IBM Tivoli Monitoring v5.1.1 warehouse pack must be installed
#       2 - Any warehouse pack depending on IBM Tivoli Monitoring v5.1.1 
#           must be installed.

# To do:
#       UserID and Passwords or the required databases 

# Examples
#CDW_DB=twh_cdw
#CDW_USER=db2admin
#CDW_PW=db2admin

#MART_DB=twh_mart
#MART_USER=db2admin
#MART_PW=db2admin

#MD_DB=twh_md
#MD_USER=db2admin
#MD_PW=db2admin


# set -x

#MART_Pre_Extract Step
echo "MART_Pre_Extract Step starting ..."
sqlscript.sh BWM BWM_m05_s010_mart_pre_extract $MART_DB $MART_USER $MART_PW 
if [ "$?" -ne "0" ] ; then
echo "error in the MART_Pre_Extract Step"
 echo "$?"
 exit
fi
echo "MART_Pre_Extract Step finished"
echo ""

# set -x
#MART_Extract Step
echo "MART_Extract Step starting ..."
sqlscript.sh BWM BWM_m05_s020_mart_extract $CDW_DB $CDW_USER $CDW_PW $MART_DB $MART_USER $MART_PW
if [ "$?" -ne "0" ] ; then
echo "error in the MART Extract Step"
 echo "$?"
 exit
fi
echo "MART Extract Step finished"
echo ""

#Load Step
echo "Load Step starting ..."
sqlscript.sh BWM BWM_m05_s030_mart_load $MART_DB $MART_USER $MART_PW
if [ "$?" -ne "0" ] ; then
echo "error in the Load Step"
 echo "$?"
 exit
fi
echo "Load Step finished"
echo ""

#Rollup step
echo "Starting Rollup step ..."
bash rollup.sh BWM F_TX_ND_HOUR STG_TX_ND_HR  $MART_DB $MART_USER $MART_PW $MD_DB $MD_USER $MD_PW BWM_m05_s040_Rollup
result="$?"
if [ $result -ne "0" ] ; then
 echo "error in the Rollup step"
 exit "$result"
fi
echo "Rollup step finished"
echo ""

#Mart_Prune step
echo "Starting Mart_Prune step ..."
#bash sqlscript.sh BWM BWM_m05_s050_Mart_Prune $MART_DB $MART_USER $MART_PW
result="$?"
if [ $result -ne "0" ] ; then
 echo "error in the Mart_Prune step"
 exit "$result"
fi
echo "Mart_Prune step finished"
echo ""


