-------------------------------------------------------------------------------
--   OCO Source Materials
--
--   Licensed Materials - Property of IBM
--
--   5724-C02
--
--   (C) Copyright IBM Corp. 2003  All Rights Reserved.
--
--   US Government Users Restricted Rights - Use, duplication or
--   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-------------------------------------------------------------------------------
--    File Information: %W%
--    Revision: %I%
--    Date: %G% %U%
-------------------------------------------------------------------------------

--------------------------------
-- BWM_TX_NODE
--------------------------------

-- prune extract
-- delete data from fact tables that is older
-- than a particular point in time

-- log the fact that the fact table was pruned

--#VERSION 1.1.0.1.0

--#EXECUTE_AT_TARGET
INSERT INTO BWM.PRUNE_MART_LOG VALUES(
    CURRENT TIMESTAMP-CURRENT TIMEZONE,
    'BWM.F_TX_ND_HOUR',
    (
     SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL
     WHERE TABLE_NAME='BWM.F_TX_ND_HOUR'
    ),
    (
     SELECT COUNT(*) FROM BWM.F_TX_ND_HOUR F
     WHERE
      (DATE(MEAS_HOUR+
       (
        SELECT PMARTC_DURATION
        FROM BWM.PRUNE_MART_CONTROL P
        WHERE P.TABLE_NAME='BWM.F_TX_ND_HOUR'
       ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
      )
    )
  );

--#EXECUTE_AT_TARGET
DELETE FROM BWM.F_TX_ND_HOUR F
 WHERE
  DATE(MEAS_HOUR+
   (
    SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL P
    WHERE P.TABLE_NAME='BWM.F_TX_ND_HOUR'
   ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
    ;

--#EXECUTE_AT_TARGET
INSERT INTO BWM.PRUNE_MART_LOG VALUES(
    CURRENT TIMESTAMP-CURRENT TIMEZONE,
    'BWM.F_TX_ND_DAY',
    (
     SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL
     WHERE TABLE_NAME='BWM.F_TX_ND_DAY'
    ),
    (
     SELECT COUNT(*) FROM BWM.F_TX_ND_DAY F
     WHERE
      (DATE(MEAS_DATE+
       (
        SELECT PMARTC_DURATION
        FROM BWM.PRUNE_MART_CONTROL P
        WHERE P.TABLE_NAME='BWM.F_TX_ND_DAY'
       ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
      )
    )
  );

--#EXECUTE_AT_TARGET
DELETE FROM BWM.F_TX_ND_DAY F
 WHERE
  DATE(MEAS_DATE+
   (
    SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL P
    WHERE P.TABLE_NAME='BWM.F_TX_ND_DAY'
   ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
    ;

--#EXECUTE_AT_TARGET
INSERT INTO BWM.PRUNE_MART_LOG VALUES(
    CURRENT TIMESTAMP-CURRENT TIMEZONE,
    'BWM.F_TX_ND_WEEK',
    (
     SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL
     WHERE TABLE_NAME='BWM.F_TX_ND_WEEK'
    ),
    (
     SELECT COUNT(*) FROM BWM.F_TX_ND_WEEK F
     WHERE
      (DATE(MEAS_DATE+
       (
        SELECT PMARTC_DURATION
        FROM BWM.PRUNE_MART_CONTROL P
        WHERE P.TABLE_NAME='BWM.F_TX_ND_WEEK'
       ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
      )
    )
  );

--#EXECUTE_AT_TARGET
DELETE FROM BWM.F_TX_ND_WEEK F
 WHERE
  DATE(MEAS_DATE+
   (
    SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL P
    WHERE P.TABLE_NAME='BWM.F_TX_ND_WEEK'
   ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
    ;

--#EXECUTE_AT_TARGET
INSERT INTO BWM.PRUNE_MART_LOG VALUES(
    CURRENT TIMESTAMP-CURRENT TIMEZONE,
    'BWM.F_TX_ND_MONTH',
    (
     SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL
     WHERE TABLE_NAME='BWM.F_TX_ND_MONTH'
    ),
    (
     SELECT COUNT(*) FROM BWM.F_TX_ND_MONTH F
     WHERE
      (DATE(MEAS_DATE+
       (
        SELECT PMARTC_DURATION
        FROM BWM.PRUNE_MART_CONTROL P
        WHERE P.TABLE_NAME='BWM.F_TX_ND_MONTH'
       ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
      )
    )
  );

--#EXECUTE_AT_TARGET
DELETE FROM BWM.F_TX_ND_MONTH F
 WHERE
  DATE(MEAS_DATE+
   (
    SELECT PMARTC_DURATION FROM BWM.PRUNE_MART_CONTROL P
    WHERE P.TABLE_NAME='BWM.F_TX_ND_MONTH'
   ))<DATE(CURRENT TIMESTAMP-CURRENT TIMEZONE)
    ;
