----------------------------------------------------------------------------------------------------
--   OCO Source Materials
--
--   Licensed Materials - Property of IBM
--
--   5724-C02
--
--   (C) Copyright IBM Corp. 2003  All Rights Reserved.
--
--   US Government Users Restricted Rights - Use, duplication or
--   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
----------------------------------------------------------------------------------------------------
--    File Information: %W%
--    Revision: %I%
--    Date: %G% %U%
----------------------------------------------------------------------------------------------------

--#iftag fixpack_5

-------------------------------------------------------------------------------------------
-- Insert data into control table for pruning data from all fact tables.
-- A date duration is decimal(8,0) and has the format yyyymmdd.
-------------------------------------------------------------------------------------------
DECLARE GLOBAL TEMPORARY TABLE PRUNE_MART_CONTROL(
    TABLE_NAME       VARCHAR(120) NOT NULL,
    PMARTC_DURATION  DECIMAL(8,0) NOT NULL)
    WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED
    ;
-------------------------------------------------------------------------------------------
--Set Pruning for fact tables
-------------------------------------------------------------------------------------------
INSERT INTO SESSION.PRUNE_MART_CONTROL VALUES ('BWM.F_TX_ND_HOUR',00000300);
INSERT INTO SESSION.PRUNE_MART_CONTROL VALUES ('BWM.F_TX_ND_DAY',00000300);
INSERT INTO SESSION.PRUNE_MART_CONTROL VALUES ('BWM.F_TX_ND_WEEK',00010000);
INSERT INTO SESSION.PRUNE_MART_CONTROL VALUES ('BWM.F_TX_ND_MONTH',00010000);

INSERT INTO BWM.PRUNE_MART_CONTROL
 SELECT
  S.TABLE_NAME AS TABLE_NAME,
  S.PMARTC_DURATION AS PMARTC_DURATION
 FROM
  SESSION.PRUNE_MART_CONTROL S
 WHERE
  NOT EXISTS
  (
   SELECT 1
   FROM BWM.PRUNE_MART_CONTROL T
   WHERE T.TABLE_NAME=S.TABLE_NAME
  );


INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -1,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 10',
    'Service Level Threshold 1',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -2,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 20',
    'Service Level Threshold 2',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -3,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 30',
    'Service Level Threshold 3',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -4,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 40',
    'Service Level Threshold 4',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -5,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 50',
    'Service Level Threshold 5',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

INSERT INTO BWM.T_TX_ND_METRIC VALUES (
    -6,
    1,
    0,
    'Not used',
    'Value of The Violation Threshold of Severity 60',
    'Service Level Threshold 6',
    'QTY',
    'N',
    'Y',
    'N',
    'N',
    'IBM Tivoli Monitoring For Transaction Performance 5.2');

--#endtag fixpack_5
