######################################################################
#
# (C) Copyright IBM Corp. 2002.  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#
#
#######################################################################
#
#-    File Information: %W%
#-    Revision: %I%
#-    Date: %G% %U%

# This script allows you to run the BWM_c10_ETL1_Process 
# by command line

# Interpreter Required:
#       NT/2000 = BASH
#       Unix    = SH (Bourne Shell)

# Install Steps Required Before this Script Executes:
#       1 - IBM Tivoli Monitoring v5.1.1 warehouse pack must be installed
#       2 - Any warehouse pack depending on IBM Tivoli Monitoring v5.1.1 
#           must be installed.

# To do:
#       UserID and Passwords or the required databases 

# Examples
TMTP_SRC=star
TMTP_USER=db2admin
TMTP_PW=db2admin

CDW_DB=twh_cdw
CDW_USER=db2admin
CDW_PW=db2admin

MART_DB=twh_mart
MART_USER=db2admin
MART_PW=db2admin

MD_DB=twh_md
MD_USER=db2admin
MD_PW=db2admin


# set -x

#Pre_Extract Step
echo "pre_Extract Step starting ..."
sqlscript.sh BWM BWM_c10_s010_pre_extract $CDW_DB $CDW_USER $CDW_PW 
if [ "$?" -ne "0" ] ; then
echo "error in the pre_Extract Step"
 echo "$?"
 exit
fi
echo "pre_Extract Step finished"
echo ""

# set -x
#TMTP_Extract Step
echo "Extract Step starting ..."
sqlscript.sh BWM BWM_c10_s020_extract $TMTP_SRC $TMTP_USER $TMTP_PW $CDW_DB $CDW_USER $CDW_PW
if [ "$?" -ne "0" ] ; then
echo "error in the Extract Step"
 echo "$?"
 exit
fi
echo "Extract Step finished"
echo ""

# Transform and Load Step
echo "Transform and Load Step starting ..."
sqlscript.sh BWM BWM_c10_s030_transform_load $CDW_DB $CDW_USER $CDW_PW
if [ "$?" -ne "0" ] ; then
echo "error in the Transform and Load Step"
 echo "$?"
 exit
fi
echo "Transform and Load Step finished"
echo ""


